// Lösungen zu "Richard Kaiser: C++ mit dem Borland C++Builder 2007", ISBN: 978-3-540-69575-2
// Copyright Richard Kaiser, 2007. http://www.rkaiser.de. All rights reserved.
// Diese Quelltexte dürfen in eigenen Programmen verwendet werden, wenn sie einen Hinweis auf die Quelle (die ersten beiden Zeilen) enthalten. In keinem Fall wird eine Haftung für direkte, indirekte, zufällige oder Folgeschäden übernommen, die sich aus der Nutzung ergeben.
// It is permitted to use this source text in programs of your own, provided that it contains a reference to the source (the first two lines above). All liabilities for use of the code are disclaimed.

// --------------- Aufgaben 3.12.13 ------------------------

// --------------- Aufgabe 1 -------------------------------

void ShowTempPath()
{
char lpBuffer[MAX_PATH];
DWORD result=GetTempPath(MAX_PATH,lpBuffer);
if (result == 0)
  Form1->Memo1->Lines->Add("Fehler");
else if (result > MAX_PATH)
  Form1->Memo1->Lines->Add("Puffer zu klein");
Form1->Memo1->Lines->Add(lpBuffer);
}


// --------------- Aufgabe 2 -------------------------------

void ShowDriveStrings()
{
const DWORD BufSize = 4*('Z'-'A'+1)+1;
char lpBuffer[BufSize];
const DWORD result=GetLogicalDriveStrings(BufSize,lpBuffer);
if (result == 0)
  Form1->Memo1->Lines->Add("Fehler");
else if (result > BufSize)
  Form1->Memo1->Lines->Add("Puffer zu klein");
// lpBuffer="c:\<null>d:\<null><null>
// position: 0        4        8

int i=0;
while ((*(lpBuffer+i)!='\0') && (i<BufSize))
  {
    Form1->Memo1->Lines->Add(lpBuffer+i);
    i=i+4;
  }

// oder z.B.
// for (LPTSTR p=lpBuffer; *p!='\0'; p=p+4)
//    Form1->Memo1->Lines->Add(p);
}

